import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLDecoder;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Posting {

	public String username = "";
	public String heading = "";
	public String date = "";
	public int postNr = 0;
	public int postSeqNr = 0;
	String posting = "";
	ArrayList<String> ignoreHosts = null;
	public int pageNr = 0;
	String root = "";
	int threadNr;
	
	public Posting(String root,int threadNr, ArrayList<String> lines, ArrayList<String> ignoreHosts,
			int pageNr) {
		boolean isPostBody = false;
		boolean isHeader = true;
		
		this.root = root;
		this.ignoreHosts = ignoreHosts;
		this.pageNr = pageNr;
		this.threadNr = threadNr;
		
		int lineNr = 0;
		for (String line : lines) {
			lineNr ++;
			String lineTrimmed = line.trim();
			if (isPostBody && (lineNr == 1) && lineTrimmed.startsWith("<p><strong>")) {
				String linex = lineTrimmed.substring(11);
				heading = linex.substring(0, linex.indexOf("</strong>"));
				
			}
			if (lineTrimmed.startsWith("<div class=\"userbadge-username\">")) {
				isHeader = false;
				if (lineTrimmed.length() > 40) {
					String linex = lineTrimmed.substring(40);
					username = linex.substring(linex.indexOf("\">") + 2);
					username = username.substring(0, username.indexOf("</a>"));
				}
			}

			if (lineTrimmed.startsWith("<div class=\"forum-post\"><a name=\"")) {
				String linex = lineTrimmed.substring(33);
				linex = linex.substring(0, linex.indexOf('"'));
				postNr = Integer.parseInt(linex);
			}

			if (lineTrimmed
					.startsWith("<span class=\"forum-post-seq pull-right hidden-xs\">")) {
				isHeader = false;
				if (lineTrimmed.length() > 40) {
					String linex = lineTrimmed.substring(40);
					linex = linex.substring(linex.indexOf("\">") + 2);
					linex = linex.substring(0, linex.indexOf("</"));
					postSeqNr = Integer.parseInt(linex);
				}
			}

			if (lineTrimmed.startsWith("<div class=\"forum-post-header\">")) {
				isHeader = true;
			}

			if (isHeader && lineTrimmed.startsWith("Posted:")) {
				date = lineTrimmed.substring(8);
			}

			if (line.startsWith("                </div>")) {
				isPostBody = false;
			}
			if (isPostBody) {
				posting += line;// + "\n";
			}
			if (line.startsWith("                <div class=\"forum-post-body\">")) {
				isPostBody = true;
				lineNr=0;
			}
		}
		ReplaceStyles();
		ReplaceARefs();
		GetImages();
		ReplaceYoutube();
	}

	private void ReplaceStyles()
	{
		posting = posting.replaceAll(Pattern.quote("font-family"), "no-font-family");
	}
	
	private void ReplaceYoutube() {
		boolean found = false;
		do {
			found = false;
			Pattern p = Pattern.compile("<iframe(.+)</iframe>");
			Matcher m = p.matcher(posting);

			if (m.find()) {
				found = true;
				String codeGroup = m.group(1);
				if (codeGroup.contains("embed/")) {
					String video = codeGroup
							.substring(codeGroup.indexOf("embed/") + 6);
					if (codeGroup.contains("?wmode=")) {
						video = video.substring(0, video.indexOf("?wmode="));
					} else {
						video = video.substring(0, video.indexOf("\""));
					}

					String videoPreview = root + "youtube/" + video + "/hqdefault.jpg";

					LoadResource("https://i.ytimg.com/vi", "/" + video
							+ "/hqdefault.jpg", root +"youtube");
					String newVideoTag = "<a href=\"https://youtu.be/" + video
							+ "\">" + "<img src=\"" + videoPreview
							+ "\" width=\"320\">" + "</a>";
					posting = posting.replaceFirst(p.pattern(), newVideoTag);

				} else {
					System.out.println("Problems detecting video url:" + codeGroup);
				}

			}
		} while (found);
	}

	private void ReplaceARefs() {
		String repl = "http://www.thereminworld.com/forums/T/"+threadNr+"?post=";
		if (posting.contains(repl)) {
			posting = posting.replaceAll(Pattern.quote(repl) + "\\d+", "");
		}
	}

    public static String decodeValue(String value) {
        try {
            return URLDecoder.decode(value, StandardCharsets.UTF_8.toString());
        } catch (UnsupportedEncodingException ex) {
            throw new RuntimeException(ex.getCause());
        }
    }
    
	private boolean LoadResource(String host, String url, String Subfolder) {
		String fileUrl = Subfolder + url;
		if (fileUrl.startsWith("/")) {
			fileUrl = url.substring(1);
		}
		fileUrl = decodeValue(fileUrl);
		if (fileUrl.endsWith(".jpg?raw=1"))
		{
			fileUrl = fileUrl.replaceAll(Pattern.quote(".jpg?raw=1"), ".jpg");
		}
		if (new File(fileUrl).exists()) {
			return true;
		}

		Path p = Paths.get(fileUrl);
		Path folder = p.getParent();
		new File(folder.toUri()).mkdirs();

		System.out.print("Reading: " + host + url);
		try (BufferedInputStream in = new BufferedInputStream(new URL(host
				+ url).openStream());
				FileOutputStream fileOutputStream = new FileOutputStream(
						fileUrl)) {
			byte dataBuffer[] = new byte[1024];
			int bytesRead;
			while ((bytesRead = in.read(dataBuffer, 0, 1024)) != -1) {
				fileOutputStream.write(dataBuffer, 0, bytesRead);
			}
			System.out.println(" SUCESS");
			return true;
		} catch (java.io.FileNotFoundException e) {
			System.out.println(" ERROR");
		} catch (java.net.UnknownHostException e) {
			System.out.println(" ERROR");
		} catch (java.io.IOException e) {
			System.out.println(" ERROR");
		}

		catch (Exception e) {
			e.printStackTrace();
		}
		
		return false;

	}

	private void GetImages() {
		String line = posting;
		while (line.contains("<img ")) {
			line = line.substring(line.indexOf("<img ") + 4);
			if (line.contains(">")) {
				String src = line.substring(0, line.indexOf(">"));
				if (line.contains("src=\"")) {
					src = src.substring(src.indexOf("src=\"") + 5);
					src = src.substring(0, src.indexOf("\""));
					if (src.startsWith("data:")) {
					
					}
					else if (src.startsWith("http")) {
						boolean isSecure = true;

						for (String ignoreHost : ignoreHosts) {
							if (src.startsWith(ignoreHost)) {
								isSecure = false;
							}
						}

						if (isSecure) {
							int pos = src.substring(8).indexOf("/") + 8;
							String httphost = src.substring(0, pos);
							String host = "";
							if (httphost.startsWith("https://")) {
								host = httphost.substring(8);
							} else if (httphost.startsWith("http://")) {
								host = httphost.substring(7);
							} else {
								System.out.println("Format error in host:"
										+ httphost);
							}

							String url = src.substring(pos);
							if (!LoadResource(httphost, url, root+"ext/" + host))
							{
								posting = posting.replaceAll(Pattern.quote(src), "noimg.png");
							}
						}
					} else {
						LoadResource("http://www.thereminworld.com", src, root);
					}
				}
			}
		}
		String repl;
		repl = "http://www.thereminworld.com/forums/T/"+threadNr+"?post=";
		if (posting.contains(repl)) {
			posting = posting.replaceAll(Pattern.quote(repl) + "\\d+", "");
		}
		repl = "src=\"/";
		if (posting.contains(repl)) {
			posting = posting.replaceAll(Pattern.quote(repl), "src=\""+root);
		}
		repl = "src=\"https://";
		if (posting.contains(repl)) {
			posting = posting.replaceAll(Pattern.quote(repl), "src=\""+root+"ext/");
		}
		repl = "src=\"http://";
		if (posting.contains(repl)) {
			posting = posting.replaceAll(Pattern.quote(repl), "src=\""+root+"ext/");
		}
	}

	@Override
	public String toString() {
		String s = "";
		s += "<br />" + "\n";
		if (!heading.isEmpty())
		{
			s+= "<h1>"+heading+"</h1>"+ "\n";
		}
		s += "<b>" + username
				+ " <span style=\"font-size:0.7em;color:LightGray\">" + date
				+ "</span></b>" + "<span style=\"font-size:0.7em;\"> ["
				+ postSeqNr + "]</span>" + "\n";
		s += "<hr />" + "\n";
		s += "<a name=\"" + postNr + "\"> </a>\n";
		s += posting;

		return s;
	}
}
